-- This file is for lua-functionality that is specific to the dino ruleset.

function tech_researched_callback(tech, player, source)
  future_start_str = "Future Tech."
  truncated_tech_str = string.sub(tech:name_translation(), 1, string.len(future_start_str))
  truncated_tech_str = future_start_str
  if truncated_tech_str == future_start_str and source == "researched" then
    edit.add_player_history(player, 10)
    notify.player(nil, "%s nation researched a Future Tech. and gained 10 culture",
                  player.nation:name_translation())
  end

  -- continue processing
  return false
end

signal.connect("tech_researched", "tech_researched_callback")


function disaster_occurred_callback(disaster, city, had_internal_effect)
  if had_internal_effect then
    notify.all("%s in %s", disaster:name_translation(), city.name)
  end
end

signal.connect("disaster_occurred", "disaster_occurred_callback")


function city_size_change_callback(city, change, reason)
  if reason == "plague" and city.owner.ai_controlled then
    return true
  end
  if reason == "migration_from" then
    notify.player(nil, "Migrants left city %s, was size %d", city.name, city.size)
  end
  if reason == "migration_to" then
    notify.player(nil, "Migrants arrived city %s, now size %d", city.name, city.size)
  end
  return false
end

signal.connect("city_size_change", "city_size_change_callback")


function report_culture_callback(turn, year)
  if turn % 30 == 15 then
--  if true then
    culture_str = ""
    culture_table = {}
    for player in players_iterate() do
      if player.nation:name_translation() ~= "Animal Kingdom" and
          player.nation:name_translation() ~= "Barbarian" and
          player.nation:name_translation() ~= "Pirate" then
        culture_table[player.nation:name_translation()] = player:culture()
      end
    end
--    table.sort(culture_table)
    for n, c in pairs(culture_table) do
      st = string.format("%s nation has %d culture.\n", n, c)
      culture_str = culture_str .. st
    end
    notify.player(nil, culture_str)
  end
  return false
end

signal.connect("turn_started", "report_culture_callback")

